#!/usr/local/bin/perl

use WWW::Mechanize;
use Net::SMTP;
use Net::POP3;
use utf8;
use FindBin;

###-----ユーザー毎に定義する値 その１-----

#1.予約を取りたい日付
#  新日本海フェリーの予約ページ、htmlのソースファイルから調べる
#  ex $hMmDd = '0813';  #8月13日
$hMmDd = 'xxxxx' ;

#2.予約を取りたい航路
#  新日本海フェリーの予約ページ、htmlのソースファイルから調べる
#  ex $hKukan = '09';  #新潟 → 小樽
$hKukan = 'xx' ;

#3.メールの発信元、発信先
# From:
# ex $FromAddress = 'from@aaa.bbbb.xx.jp' ;
$FromAddress = 'xxx@xxx.xxx.xx' ;

# To:
# ex1 $ToAddress = 'to@aaa.bbbb.xx.jp' ;
# ex2 $ToAddress = 'to1@aaa.bbbb.xx.jp, to2@ccc.dddd.yy.jp' ;
$ToAddress = 'xxx@xxx.xxx.xx' ;

#4. メールサーバーの設定
# ここはメール発信のための設定です
# ご自身のメーラーと同じ設定にして下さい
# POPサーバー
$Pop3Server = '' ;
# SMTPサーバー
$SmtpServer = '' ;
# ユーザーID
$UserId     = '' ;
# パスワード
$PopPasswd  = '' ;

#5. その他
#このプログラムが動いていることを報せる為、プログラムが動いた時刻が
#毎時 0分から9分なら予約の有無にかかわらずメールは発信する
#値が0なら発信しない、値が0なら発信する
#デフォルト値は '発信しない'
$ValidAlive = '0' ;

###-----ユーザー毎に定義する値 その１ ここまで-----

#ログファイル open
$script_dir = $FindBin::Bin ;
$log_file   = 'chk_snf.log' ;

open LOG, ">>$script_dir/$log_file" ;

# 0.5秒待つ
select(undef, undef, undef, 0.5);

#WWW::Mechanizeの初期化
my $mech = WWW::Mechanize->new();

#アクセス先
my $url = "http://www.snf.jp/yoyaku/entryVacantSts.php" ;

#最初のページにアクセス
$mech->get($url);

#日付、航路のフィールドを選択
$mech->select("hMmDd",$hMmDd) ;
$mech->select("hKukan",$hKukan) ;

#照会のボタンをクリックして目的のページへアクセス
$mech->click_button(value => "  照会  ");

#ページの内容をコピーし、改行コードを統一
$wwwbody = $mech->content ;
$wwwbody =~ s/\x0D\x0A|\x0D|\x0A/\n/g;

# $mech->content に入ったhtml BODY部を改行コードでsplitし、１行ごとに分割
@lines = split(/\n/, $wwwbody);

# 空き状況の行をマッチさせ、値を抽出
$count = 0;
foreach $i (@lines){
    if ($i =~ /      <TD BGCOLOR="#FFFFFF" ALIGN="center"><FONT SIZE="2" CLASS="text2">/){
	@tmp = split(/<|>/, $i);
	$aki[$count] = $tmp[4];
	$count++ ;
    }
}

# Class2, Class2 Bed, S bed class1, class special, class special A, suite, bike, car

if ($aki[0] ne "×"){$R2 = 'o';}else{$R2 = 'x';} #2等
if ($aki[1] ne "×"){$B2 = 'o';}else{$B2 = 'x';} #2等寝台
if ($aki[2] ne "×"){$BS = 'o';}else{$BS = 'x';} #S寝台
if ($aki[3] ne "×"){$R1 = 'o';}else{$R1 = 'x';} #1等
if ($aki[4] ne "×"){$RT = 'o';}else{$RT = 'x';} #特等
if ($aki[5] ne "×"){$TA = 'o';}else{$TA = 'x';} #特等A
if ($aki[6] ne "×"){$SR = 'o';}else{$SR = 'x';} #スイート
if ($aki[7] ne "×"){$CA = 'o';}else{$CA = 'x';} #車
if ($aki[8] ne "×"){$BK = 'o';}else{$BK = 'x';} #バイク

$rsv = 0;

###-----ユーザー毎に定義する値 その2 -----
#調べたい空室についてif文を書く
# ex1 1等と車
# if ( ($R1 ne 'x') && ($CA ne 'x') ){
#	$rsv = 1;
#}

# ex2 S寝台とバイク
#if ( ($BS ne 'x') && ($BK ne 'x') ){
#	$rsv = 1 ;
#}

# ex3 2等もしくは2等寝台 で 車の空き
#if ( ( ($R2 ne 'x') || ($B2 ne 'x') ) && ($CA ne 'x') ){
#	$rsv = 1;
#}

###-----ユーザー毎に定義する値 その2 ここまで-----


##現在時刻の取得
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
	$now =sprintf("%02d/%02d/%02d %02d:%02d:%02d", ($year - 100), $mon, $mday, $hour, $min, $sec);

$alive = 0;

if ($ValidAlive != 0){
	#分が0から9なら、プログラム起動中確認メール発信フラグをONに
	if ( $min < 10 ){
		$alive = 1;
	}
}

##予約に空きがなく、alive通知の必要がなければメール発信処理終了
if ( ($rsv == 0) && ($alive == 0) ){
    print     "$now normal end without sending mail.\n";
	print LOG "$now normal end without sending mail.\n";
	close(LOG) ;
    exit 0 ;
}

#発信メールの本文作成
$body = '';

if ($alive != 0){
    $body = "Program alive\n";
}

$body = $body . 
		"Class2     : $R2\n" .
		"Class2 Bed : $B2\n" .
		"S Bed      : $BS\n" . 
		"Class1     : $R1\n" .
		"Class SP   : $RT\n" .
		"Class SP A : $TA\n" .
		"Suite      : $SR\n" .
		"Car        : $CA\n" .
		"Bike       : $BK\n" ;
    


#発信メールのSubject作成
$subject = "SNF Ferry Yoyaku ";

if ($rsv == 1){
    $subject = $subject . "Aki Ari";
}

# From: と To: 指定
$from = $FromAddress ;
$to   = $ToAddress ;

#$smtp->to()の引数はリストでなくてはならない
#To:が複数の場合にエラーするので、空白を削除の後、リストに変換

$to_wk = $to;
$to_wk =~ s/\s+//g;
@smtp_to = split(/,/, $to_wk);

#Pop before SMTP
$pop = Net::POP3->new($Pop3Server);

if($pop->login($UserId, $PopPasswd) >= 0) {
$pop->quit; # 接続できたらPOP3終了
}else{
	print     "$now abnormal end. Error on Pop3 server access.\n"; # 接続できなかった場合
	print LOG "$now abnormal end. Error on Pop3 server access.\n"; 
	close(LOG) ;
	exit 1 ;
} 

#メール発信
$smtp = Net::SMTP->new($SmtpServer, Hello=>$SmtpServer);

$smtp->mail($from);
$smtp->to(@smtp_to);
# データ
$smtp->data();
$smtp->datasend("From:$from\n");
$smtp->datasend("To:$to\n");
$smtp->datasend("Subject:$subject\n\n");
# 本文
$smtp->datasend($body);
# データ終端
$smtp->dataend();
# 接続終了
$smtp->quit; 
#
print     "$now normal end with sending a internet mail.\n";
print LOG "$now normal end with sending a internet mail.\n";
close(LOG);

### end of program
